IMPORT util
DEFINE datadir STRING
MAIN
  DEFINE w STRING
  DEFINE version FLOAT
  DEFINE remoteName STRING
  DEFINE needUpload BOOLEAN
  RUN "cp myGICAPI.js webcomponents/web"
  LET version=parseMajorMinor(ui.Interface.getFrontEndVersion())
  DISPLAY "version:",version
  LET needUpload=fgl_getenv("FGL_WEBSERVER_HTTP_USER_AGENT") IS NULL AND version<3.1
  DISPLAY "needUpload=",needUpload
  DISPLAY ui.Interface.getFrontEndName()
  IF ui.Interface.getFrontEndName()=="GDC" AND needUpload THEN
    CALL ui.Interface.frontcall("standard","feinfo", ["datadirectory"],[datadir])
    DISPLAY "datadir:",datadir
    IF datadir IS NULL THEN
      DISPLAY "datadir must be available"
      EXIT PROGRAM 1
    END IF
    --even with GDC 3.00 we need to upload the component because for some reasons
    --the automatic built in file transfer tramsmission fails
    --for GDC 3.1 it works without uploading
    CALL uploadComponent()
  END IF
  OPEN FORM f FROM "main"
  DISPLAY FORM f
  INPUT BY NAME w WITHOUT DEFAULTS ATTRIBUTE(UNBUFFERED)
    ON ACTION show
      IF needUpload THEN
       --we need to push the pdf to the client side
       LET remoteName=sfmt("%1%2",datadir,"hello.pdf")
       CALL fgl_putfile("hello.pdf",remoteName)
       CALL ui.interface.frontcall("webcomponent", "call", ["formonly.w","displayPDF","file://"||remoteName], [])
     ELSE
       LET remoteName=ui.Interface.filenameToURI("hello.pdf")
       DISPLAY remoteName
       CALL ui.interface.frontcall("webcomponent", "call", ["formonly.w","displayPDF",remoteName], [])
     END IF

  END INPUT
END MAIN


FUNCTION fileList()
  DEFINE f DYNAMIC ARRAY OF STRING
  LET f[f.getLength()+1]="web/myGICAPI.js"
  LET f[f.getLength()+1]="web/web.html"
  LET f[f.getLength()+1]="web/viewer.css"
  LET f[f.getLength()+1]="web/compatibility.js"
  LET f[f.getLength()+1]="web/l10n.js"
  LET f[f.getLength()+1]="web/debugger.js"
  LET f[f.getLength()+1]="web/viewer.js"
  LET f[f.getLength()+1]="web/images/texture.png"
  LET f[f.getLength()+1]="web/images/toolbarButton-viewThumbnail.png"
  LET f[f.getLength()+1]="web/images/toolbarButton-viewOutline.png"
  LET f[f.getLength()+1]="web/images/toolbarButton-viewAttachments.png"
  LET f[f.getLength()+1]="web/images/toolbarButton-sidebarToggle.png"
  LET f[f.getLength()+1]="web/images/toolbarButton-pageUp.png"
  LET f[f.getLength()+1]="web/images/toolbarButton-pageDown.png"
  LET f[f.getLength()+1]="web/images/toolbarButton-secondaryToolbarToggle.png"
  LET f[f.getLength()+1]="web/images/toolbarButton-zoomOut.png"
  LET f[f.getLength()+1]="web/images/toolbarButton-zoomIn.png"
  LET f[f.getLength()+1]="web/images/toolbarButton-menuArrows.png"
  LET f[f.getLength()+1]="web/images/toolbarButton-viewThumbnail@2x.png"
  LET f[f.getLength()+1]="web/images/toolbarButton-viewOutline@2x.png"
  LET f[f.getLength()+1]="web/images/toolbarButton-viewAttachments@2x.png"
  LET f[f.getLength()+1]="web/images/toolbarButton-sidebarToggle@2x.png"
  LET f[f.getLength()+1]="web/images/toolbarButton-pageUp@2x.png"
  LET f[f.getLength()+1]="web/images/toolbarButton-pageDown@2x.png"
  LET f[f.getLength()+1]="web/images/toolbarButton-secondaryToolbarToggle@2x.png"
  LET f[f.getLength()+1]="web/images/toolbarButton-zoomOut@2x.png"
  LET f[f.getLength()+1]="web/images/toolbarButton-zoomIn@2x.png"
  LET f[f.getLength()+1]="web/images/toolbarButton-menuArrows@2x.png"
  LET f[f.getLength()+1]="web/locale/locale.properties"
  LET f[f.getLength()+1]="web/locale/en-US/viewer.properties"
  LET f[f.getLength()+1]="build/pdf.worker.js"
  LET f[f.getLength()+1]="build/pdf.js"
  RETURN f
END FUNCTION

FUNCTION uploadComponent()
  DEFINE ftprefix STRING
  DEFINE flist DYNAMIC ARRAY OF STRING
  DEFINE i INT
  LET ftprefix=datadir,"/webcomponents"
  CALL clientExecute(sfmt('mkdir "%1"',ftprefix))
  CALL clientExecute(sfmt('mkdir "%1/web"',ftprefix))
  CALL clientExecute(sfmt('mkdir "%1/web/locale"',ftprefix))
  CALL clientExecute(sfmt('mkdir "%1/web/locale/en-US"',ftprefix))
  CALL clientExecute(sfmt('mkdir "%1/web/images"',ftprefix))
  CALL clientExecute(sfmt('mkdir "%1/build"',ftprefix))
  CALL ui.Interface.frontCall("standard","setwebcomponentpath",[ftprefix],[])
  LET flist=fileList()
  FOR i=1 TO flist.getLength()
    --DISPLAY "transmitting:",flist[i],"..."
    CALL fgl_putfile("webcomponents/"||flist[i],SFMT("%1/%2",ftprefix,flist[i]))
  END FOR
END FUNCTION

FUNCTION clientExecute(cmd)
  DEFINE cmd STRING
  CALL ui.Interface.frontCall("standard","execute",[cmd,1],[])
END FUNCTION

FUNCTION parseMajorMinor(version)
  DEFINE version STRING
  DEFINE fversion,testversion FLOAT
  DEFINE pointpos,major,idx INTEGER
  --cut out major.minor from the version
  LET pointpos=version.getIndexOf(".",1)
  IF pointpos==0 OR pointpos=1 THEN
    --version string did not contain a '.' , this 
    RETURN 0
  ELSE 
    LET major=version.subString(1,pointpos-1)
    IF major IS NULL OR major>100 THEN --one needs to adjust the 100 hopefully only after 300 years
      RETURN 0
    END IF
  END IF
  --go a long as possible thru the string after '.' and remember the last
  --valid conversion, so it doesn't matter if a '.' or something else is right hand side of major.minor
  LET idx=1
  LET fversion=NULL
  WHILE (testversion:=version.subString(1,pointpos+idx)) IS NOT NULL 
      AND pointpos+idx <= version.getLength() 
    LET fversion=testversion
    --DISPLAY "fversion:",fversion," out of:",version.subString(1,pointpos+idx) 
    LET idx=idx+1
  END WHILE
  RETURN IIF(fversion IS NULL,0,fversion)
END FUNCTION
